Subject: Re: [PATCH] gitweb: Show project README if available

From: Andreas Ericsson <[email-masked]>
Date: Tue, 10 Oct 2006 10:33:26 +0200

Luben Tuikov wrote:
> --- Petr Baudis <[email-masked]> wrote:
>> If the project includes a README file, show it in the summary page.
>> The usual "this should be in the config file" argument does not apply here
>> since this can be larger and having such a big string in the config file
>> would be impractical.
>>
>> I don't know if this is suitable upstream, but it's one of the repo.or.cz
>> custom modifications that I've thought could be interesting for others
>> as well.
> 
> I don't see how a read-me file relates to gitweb.
> 
> People may call those files "00README" or "README.txt"
> or "README.TXT" or "README_001", etc.
> 
> The contents of such a file has nothing to do with gitweb,
> and or git.  It may work for repo.or.cz but is unlikely that
> it would work for all projects for all git repos and for all
> gitweb interfaces.
> 

Well, git isn't the right tool for everything, and umbrellas are only 
good when it rains.

> The contents of a read-me file could be quite large and thus
> not suitable for the "summary" page.  Both the contents and the
> size may not be suitable.  "repo.or.cz" is the exception, not
> the rule.
> 
> A readme file isn't written with the intent of git or gitweb.
> It is a function of the project, not the SCM used to keep it in, or
> the SCM web interface used to show it.
> 

I can quite clearly envision usage for a README file for gitweb 
exclusive usage; It would show a link to coding guidelines, 
email-addresses for mailing-lists and project maintainers, bugtracker 
urls and other things which are handy to find fast on the web but that 
you don't necessarily want to dig around inside the repo for.

the project-root/README usually holds info along the lines of
"This program is really spiffy. It does this, this and that, and if you 
configure it properly, it will Make the World a Better Place(tm)."; Too 
newbie'ish info for people looking to submit bugs, patches and suggestions.

> I don't understand why the "description"  file doesn't do what
> you want?  Do you need it to be multi-line or slightly larger?
> Why not just extend "description" and/or create/use a second
> file called "description_long" to store multi-line descriptions?
> 

I imagine description_long is what's discussed here, although README is 
the suggested name.

> Or why not extend the "description" file s.t. only the first
> line would be shown in the "description" line of "summary" and
> down below, show the rest of the description file if present?
> 

Junio suggested this 2 hours before you sent your mail, and it seems as 
reasonable now as it did then. It also makes .git/description consistent 
with how we write and show commit-messages.

-- 
Andreas Ericsson                   [email-masked]
OP5 AB                             www.op5.se
Tel: +46 8-230225                  Fax: +46 8-230231